! int render_strip_array_mix(rendertarget, simplelitvert *, int stripcount, size_t *striplens float lightx, float lighty,
!	float lightz, float lightw, float ambient)
#define x fr0
#define y fr1
#define z fr2
#define w fr3
#define lx fr4
#define ly fr5
#define lz fr6
#define lw fr7
#define nx fr8
#define ny fr9
#define nz fr10
#define nw fr11
#define ambient fr12
#define xy dr0
#define zu dr2
#define lxy dr4
#define lzw dr6
#define nxy dr8
#define nzv dr10
#define uv dr14
#define vec fv0
#define lvec fv4
#define nvec fv8
#define sq		r0
#define vertcnt		r1
#define dst		r2
#define cmd_vert	r3
#define cmd_eos		r4
#define verts		r5
#define stripcnt	r6
#define striplens	r7

.globl _render_strip_array_mix
.align 5
_render_strip_array_mix:

	mov	#224,cmd_vert	!load const for vert command	
	fmov	fr12,@-r15	!push to stack so fr12 can hold ambient
	
	shll16	cmd_vert	!shift const to correct value	
	fmov	fr14,@-r15	!push to stack so fr14 can hold u
	
	shll8	cmd_vert	!finish const shifting
	fmov	fr15,@-r15	!push to stack so fr15 can hold v
	
	mov	r4,sq		!copy target sq to r0
 	fmov	fr8,ambient	!move ambient to fr12
	
	mov.l	@striplens+, vertcnt
	add	#-32, sq	!switch to other sq

	mov.l	.Leos, cmd_eos
	bra	2f		!skip over submitting empty sq
	fschg			!!!!!switch to double loads
.align 2
1:
	pref	@sq		!submit current sq
	fschg			!!!!!switch to doubles
2:
	pref	@verts	!prefetch next vertex
	
	fmov	@verts+,xy	!load vertex x,y
	add	#32, sq		!switch to other sq

	fmov	@verts+,zu	!load vertex z,u
	mov	sq,dst		!copy target sq to r2 for write pos

	fmov	@verts+,nxy	!load normal x,y
	add	#4*4,dst	!move to vertex write pos to sq's uv
	
	flds	w,fpul		!get u
	
	fldi1	w
	
	fmov	@verts+,nzv	!load normal z,v
	
	pref	@verts		!prefetch next vertex
	ftrv	xmtrx,vec	!transform
	
	fsts	fpul,fr14
	
	flds	nw,fpul
	fipr	lvec,nvec	!do dot product between normal and light	
	
	fsts	fpul,fr15
	
	fmov	uv,@dst		!write texture u,v
	add	#4*2,dst	!move write pos to sq intensity
	
	fldi1	z
	fdiv	w,z		!start 1/w calc
	
	mov.l	cmd_vert,@sq	!write vertex command const to sq
	fcmp/gt	ambient, nw	!is the light more than ambient?
	
	!
	
	fschg			!!!!!switch to singles
	bt 3f			!if it's less than ambient, make it equal to ambient

	fmov	ambient,nw

3:	fmov	nw,@dst		!write intensity to sq
	fmul	z,y		!calc y/w

	add	#-4*3,dst	!move sq write pos for vertex z write
	fmul	z,x		!calc x/w

	fmov	z,@dst		!write 1/w to sq
	dt	vertcnt		!one less vertex to send

	fmov	y,@-dst		!write y/w to sq
	!

	bf/s	1b
	fmov	x,@-dst		!write x/w to sq
	
!we are on the last triangle of this strip, write end strip command
	dt	stripcnt
	mov.l	cmd_eos,@sq	!set end of list value at sq start
	
	mov.l	@striplens+, vertcnt
	bf	1b
	
	fmov	@r15+,fr15	!pop stack back
	fmov	@r15+,fr14	!pop stack back
	fmov	@r15+,fr12	!pop stack back
	rts
	pref	@sq		!submit last vertex
	
.align 2
.Leos:
	.long 0xf0000000
